//! @file usb_standard_request.c,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief USBu(ڑF)v
//!
//! ̧ق͕W(ڑF)(USBdl9͎Q)ɑΉUSB߲0
//! ٰ݂܂݂܂B
//! ̧ق͔WvǗɑ΂usb_specific_request.çقٰ݂Ăяo
//! ܂B
//! (ڑF)Ұ(Lqq\)usb_descriptors.çٓɊ܂܂܂B
//!
//! @version 1.2 at90usb128-demo-touchscreen-1_0_0 $Id: usb_standard_request.c,v 1.2 2006/03/13 10:19:27 rletendu Exp $
//!
//! @todo
//! @bug

//_____ ݸٰ _______________________________________________________________

#include "config.h"
#include "conf_usb.h"
#include "usb_drv.h"
#include "usb_descriptors.h"
#include "usb_standard_request.h"
#include "usb_specific_request.h"

//_____ ϸ ___________________________________________________________________

//_____ ` __________________________________________________________________

//_____ I錾 ______________________________________________________________

static void usb_get_descriptor (void);
static void usb_set_address (void);
static void usb_set_configuration (void);
static void usb_clear_feature (void);
static void usb_set_feature (void);
static void usb_get_status (void);
static void usb_get_configuration (void);
static void usb_get_interface (void);
static void usb_set_interface (void);

//_____ 錾 __________________________________________________________________

static bit zlp;
static U8  endpoint_status[NB_ENDPOINTS];

#ifdef AVRGCC
  PGM_VOID_P pbuffer;
#else
  U8 code *pbuffer;
#endif
U8 data_to_transfer;

U16 wInterface;

static U8 bmRequestType;

U8 usb_configuration_nb;
extern bit  usb_connected;
extern code S_usb_device_descriptor				usb_user_device_descriptor;
extern code S_usb_user_configuration_descriptor	usb_user_configuration_descriptor;

//! usb_enum_variable_init
//!
//! @brief ̊֐͎USBϐ܂B
//! - ߲ď
//! - ڑ
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_enum_var_init (void)
{
	U8 ep_num ;

	for( ep_num=0 ; ep_num<NB_ENDPOINTS ; ep_num++ )
	{
		endpoint_status[ep_num] = 0;
	}
	usb_connected        = FALSE;			// USB͐ڑ܂B
	usb_configuration_nb = 0    ;			// ڑԍ0łB
}

//! usb_process_request
//!
//! @brief ̊֐͊萧߲ĂɑꂽSETUPvǂœK؂Ȋ֐
//! т܂Busb_read_request֐̔oAu͎̗v̊Ǘ
//! ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//! @note	xv̈ꗗ
//! GET_DESCRIPTOR
//! GET_CONFIGURATION
//! SET_ADDRESS
//! SET_CONFIGURATION
//! CLEAR_FEATURE
//! SET_FEATURE
//! GET_STATUS
//!
void usb_process_request (void)
{
	U8 bmRequest;

	bmRequestType = Usb_read_byte();
	bmRequest     = Usb_read_byte();

	switch (bmRequest)
	{
		case GET_DESCRIPTOR:
			if (0x80 == bmRequestType) { usb_get_descriptor(); }
			else					   { usb_user_read_request(bmRequestType, bmRequest); }
			break;

		case GET_CONFIGURATION:
			if (0x80 == bmRequestType) { usb_get_configuration(); }
			else					   { usb_user_read_request(bmRequestType, bmRequest); }
			break;

		case SET_ADDRESS:
			if (0x00 == bmRequestType) { usb_set_address(); }
			else					   { usb_user_read_request(bmRequestType, bmRequest); }
			break;

		case SET_CONFIGURATION:
			if (0x00 == bmRequestType) { usb_set_configuration(); }
			else					   { usb_user_read_request(bmRequestType, bmRequest); }
			break;

		case CLEAR_FEATURE:
			if (0x02 >= bmRequestType) { usb_clear_feature(); }
			else					   { usb_user_read_request(bmRequestType, bmRequest); }
			break;

		case SET_FEATURE:
			if (0x02 >= bmRequestType) { usb_set_feature(); }
			else					   { usb_user_read_request(bmRequestType, bmRequest); }
			break;

		case GET_STATUS:
			if ((0x7F < bmRequestType) & (0x82 >= bmRequestType))
									   { usb_get_status(); }
			else					   { usb_user_read_request(bmRequestType, bmRequest); }
			break;

		case GET_INTERFACE:
			if (bmRequestType == 0x81) { usb_get_interface(); }
			else { usb_user_read_request(bmRequestType, bmRequest); }
			break;

		case SET_INTERFACE:
			if (bmRequestType == 0x01) {usb_set_interface();}
			break;

		case SET_DESCRIPTOR:
		case SYNCH_FRAME:
		default: //!< xvˎgpғǂݍݗvĂяo
			if(usb_user_read_request(bmRequestType, bmRequest) == FALSE)
			{
				Usb_enable_stall_handshake();
				Usb_ack_receive_setup();
				return;
			}
			break;
	}
}

//! usb_set_address
//!
//! ̊֐SET ADDRESSvǗ܂BAu͐Vڽpėv
//! h߂܂B
//!
//! @warning :xx޲ (֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_set_address (void)
{
	Usb_configure_address(Usb_read_byte());

	Usb_ack_receive_setup();

	Usb_send_control_in();				//!< ԒiKɑ΂0߹Ă𑗏o
	while(!Is_usb_in_ready());			//!< VڽpOɏԒiKI҂
	Usb_enable_address();
}

//! usb_set_configuration
//!
//! ̊֐SET CONFIGURATIONvǗ܂BI`Ԑݒ肪LȂA
//! ̊֐͌`Ԑݒԍɏ]Ĵ߲Ă`Ԑݒ肷usb_user_endpoint_init()
//! Ăяo܂B
//!
//! @warning :xx޲ (֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_set_configuration (void)
{
	U8 configuration_number;

	configuration_number = Usb_read_byte();

	if (configuration_number <= NB_CONFIGURATION)
	{
		Usb_ack_receive_setup();
		usb_configuration_nb = configuration_number;
	}
	else
	{
		//!< (STALLvݒ/SETUPM)ۂA܂SETUPɌ㑱OUTv
		//!< 邩܂B
		Usb_enable_stall_handshake();
		Usb_ack_receive_setup();
		return;
	}

	Usb_send_control_in();							//!< ԒiKɑ΂0߹đo

	usb_user_endpoint_init(usb_configuration_nb);	//!< ߲Č`Ԑݒ
	Usb_set_configuration_action();
}

//! usb_get_descriptor
//!
//! ̊֐GET DESCRIPTORvǗ܂BuLqqA`ԐݒLqqAu
//! Cx܂B̑SĂ̋Lqusb_user_get_descriptor֐ɂĎx
//! Ȃ΂Ȃ܂B
//! 1̌`Ԑݒ肾x܂B
//!
//! @warning :xx޲ (֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_get_descriptor (void)
{
	U16 wLength;
	U8  descriptor_type;
	U8  string_type;
	U8  dummy;
	U8  nb_byte;

	zlp             = FALSE;				/* 0߹ */
	string_type     = Usb_read_byte();		/* wValue޲ēǂݍ */
	descriptor_type = Usb_read_byte();		/* wValue޲ēǂݍ */

	switch (descriptor_type)
	{
		case DEVICE_DESCRIPTOR:
			data_to_transfer = Usb_get_dev_desc_length();	//!< sizeof (usb_user_device_descriptor);
			pbuffer          = Usb_get_dev_desc_pointer();
			break;
		case CONFIGURATION_DESCRIPTOR:
			data_to_transfer = Usb_get_conf_desc_length();	//!< sizeof (usb_user_configuration_descriptor);
			pbuffer          = Usb_get_conf_desc_pointer();
			break;
		default:
			if( usb_user_get_descriptor(descriptor_type, string_type)==FALSE )
			{
				Usb_enable_stall_handshake();
				Usb_ack_receive_setup();
				return;
			}
			break;
	}

	dummy = Usb_read_byte();				//!< wIndeẍ͖
	dummy = Usb_read_byte();
	LSB(wLength) = Usb_read_byte();			//!< wLengthǂݍ
	MSB(wLength) = Usb_read_byte();
	Usb_ack_receive_setup();				//!< SETUPM׸މ

	if (wLength > data_to_transfer)
	{
		if ((data_to_transfer % EP_CONTROL_LENGTH) == 0) { zlp = TRUE; }
		else { zlp = FALSE; }				//!< 0߹Ă̕KvȂ
	}
	else
	{
		data_to_transfer = (U8)wLength;		//!< vꂽްo
	}

	while((data_to_transfer != 0) && (!Is_usb_receive_out()))
	{
		while(!Is_usb_read_control_enabled());

		nb_byte=0;
		while(data_to_transfer != 0)			//!< Kvȕ܂ްo
		{
			if(nb_byte++==EP_CONTROL_LENGTH)	//!< ߲0傫
			{
				break;
			}
#ifndef AVRGCC
			Usb_write_byte(*pbuffer++);
#else // AVRGCCPGMԂւ̈ʒuwx܂B
#warning AVRGCCł͑uLqqߏׯ ؂̉64K޲ĂɊi[Ɖ肵܂B
			Usb_write_byte(pgm_read_byte_near((unsigned int)pbuffer++));
#endif
			data_to_transfer --;
		}
		Usb_send_control_in();
	}

	Usb_send_control_in();

	if(Is_usb_receive_out()) { Usb_ack_receive_out(); return; }	//!< νĂ̒f
	if(zlp == TRUE)
	{
		while(!Is_usb_read_control_enabled());
		Usb_send_control_in();
	}

	while(!Is_usb_receive_out());
	Usb_ack_receive_out();
}

//! usb_get_configuration
//!
//! ̊֐GET CONFIGURATIONvǗ܂B݂̌`ԐݒԍԂ܂B
//!
//! @warning :xx޲ (֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_get_configuration (void)
{
	Usb_ack_receive_setup();

	Usb_write_byte(usb_configuration_nb);
	Usb_ack_in_ready();

	while( !Is_usb_receive_out() );
	Usb_ack_receive_out();
}

//! usb_get_status
//!
//! ̊֐GET STATUSvǗ܂B̪܂ʹ߲Ă̏ԂԂ
//! ܂B
//!
//! @warning :xx޲ (֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_get_status (void)
{
	U8 wIndex;
	U8 dummy;

	dummy  = Usb_read_byte();				//!< Uǂݍ
	dummy  = Usb_read_byte();				//!< Uǂݍ
	wIndex = Usb_read_byte();

	switch(bmRequestType)
	{
		case REQUEST_DEVICE_STATUS:		Usb_ack_receive_setup();
										Usb_write_byte(DEVICE_STATUS);
										break;

		case REQUEST_INTERFACE_STATUS:	Usb_ack_receive_setup();
										Usb_write_byte(INTERFACE_STATUS);
										break;

		case REQUEST_ENDPOINT_STATUS:	Usb_ack_receive_setup();
										wIndex = wIndex & MSK_EP_DIR;
										Usb_write_byte(endpoint_status[wIndex]);
										break;
		default:
										Usb_enable_stall_handshake();
										Usb_ack_receive_setup();
										return;
	}

	Usb_write_byte(0x00);
	Usb_send_control_in();

	while( !Is_usb_receive_out() );
	Usb_ack_receive_out();
}

//! usb_set_feature
//!
//! ̊֐SET FEATUREvǗ܂BUSB`Ԃ͂̊ւɂĎx
//! ܂B
//!
//! @warning :xx޲ (֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_set_feature (void)
{
	U8 wValue;
	U8 wIndex;
	U8 dummy;

	if (bmRequestType == INTERFACE_TYPE)
	{
		//!< (STALLvݒ/SETUPM)ۂA܂SETUPɌ㑱OUTv
		//!< 邩܂B
		Usb_enable_stall_handshake();
		Usb_ack_receive_setup();
		return;
	}
	else if (bmRequestType == ENDPOINT_TYPE)
	{
		wValue = Usb_read_byte();
		dummy  = Usb_read_byte();			//!< Uǂݍ

		if (wValue == FEATURE_ENDPOINT_HALT)
		{
			wIndex = (Usb_read_byte() & MSK_EP_DIR);

			if (wIndex == EP_CONTROL)
			{
				Usb_enable_stall_handshake();
				Usb_ack_receive_setup();
				return;
			}

			Usb_select_endpoint(wIndex);
			if(Is_usb_endpoint_enabled())
			{
				Usb_enable_stall_handshake();
				Usb_select_endpoint(EP_CONTROL);
				endpoint_status[wIndex] = 0x01;
				Usb_ack_receive_setup();
				Usb_send_control_in();
			}
			else
			{
				Usb_enable_stall_handshake();
				Usb_ack_receive_setup();
				return;
			}
		}
		else
		{
			Usb_enable_stall_handshake();
			Usb_ack_receive_setup();
			return;
		}
	}
}

//! usb_clear_feature
//!
//! ̊֐SET FEATUREvǗ܂B
//!
//! @warning :xx޲ (֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_clear_feature (void)
{
	U8 wValue;
	U8 wIndex;
	U8 dummy;

	if (bmRequestType == ZERO_TYPE)
	{
		//!< (STALLvݒ/SETUPM)ۂA܂SETUPɌ㑱OUTv
		//!< 邩܂B
		Usb_enable_stall_handshake();
		Usb_ack_receive_setup();
		return;
	}
	else if (bmRequestType == INTERFACE_TYPE)
	{
		//!< (STALLvݒ/SETUPM)ۂA܂SETUPɌ㑱OUTv
		//!< 邩܂B
		Usb_enable_stall_handshake();
		Usb_ack_receive_setup();
		return;
	}
	else if (bmRequestType == ENDPOINT_TYPE)
	{
		wValue = Usb_read_byte();
		dummy  = Usb_read_byte();			//!< Uǂݍ

		if (wValue == FEATURE_ENDPOINT_HALT)
		{
			wIndex = (Usb_read_byte() & MSK_EP_DIR);

			Usb_select_endpoint(wIndex);
			if(Is_usb_endpoint_enabled())
			{
				if(wIndex != EP_CONTROL)
				{
					Usb_disable_stall_handshake();
					Usb_reset_endpoint(wIndex);
					Usb_reset_data_toggle();
				}
				Usb_select_endpoint(EP_CONTROL);
				endpoint_status[wIndex] = 0x00;
				Usb_ack_receive_setup();
				Usb_send_control_in();
			}
			else
			{
				Usb_enable_stall_handshake();
				Usb_ack_receive_setup();
				return;
			}
		}
		else
		{
			Usb_enable_stall_handshake();
			Usb_ack_receive_setup();
			return;
		}
	}
}

//! usb_get_interface
//!
//! ̊֐GET_INTERFACEvǗ܂B
//!
//! @warning :xx޲ (֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_get_interface (void)
{
	Usb_enable_stall_handshake();
	Usb_ack_receive_setup();
}

//! usb_set_interface
//!
//! ̊֐SET_INTERFACEvǗ܂B
//!
//! @warning :xx޲ (֐ޒ)
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
void usb_set_interface (void)
{
	Usb_ack_receive_setup();
	Usb_send_control_in();				//!< ԒiKɑ΂0߹đo
	while(!Is_usb_in_ready());
}
